'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const replaceToken = '--';
const varReplaceRegex = new RegExp(`(?<!var\\(\\s*)\\${replaceToken}([a-zA-Z\\-_\\d]+)`, 'gm');

function addVar(cssPropertyValue) {
  if (typeof cssPropertyValue !== 'string') {
    return cssPropertyValue;
  }

  return cssPropertyValue.replace(varReplaceRegex, 'var(--$1)');
}

function traverseVars({
  t
}) {
  return {
    StringLiteral(path) {
      var _path$parent;

      if (((_path$parent = path.parent) === null || _path$parent === void 0 ? void 0 : _path$parent.key) !== path.node) {
        path.node.value = addVar(path.node.value);
      }
    },

    TemplateElement(path) {
      var _path$parent2;

      if (((_path$parent2 = path.parent) === null || _path$parent2 === void 0 ? void 0 : _path$parent2.key) !== path.node) {
        path.node.value.raw = addVar(path.node.value.raw);
        path.node.value.cooked = addVar(path.node.value.cooked);
      }
    }

  };
}
function index ({
  types: t
}) {
  return {
    name: '@alexmchan/cssvarify',
    visitor: {
      // eslint-disable-next-line @typescript-eslint/naming-convention
      JSXAttribute(path) {
        if (['style'].includes(path.node.name.name)) {
          path.traverse(traverseVars({
            t
          }));
        }
      }

    }
  };
}

exports.default = index;
exports.traverseVars = traverseVars;
